#!/usr/bin/pl

(struct post
  (title body))

(def html (fn (text) (cat "<html>" text "</html>")))
(def body (fn (text) (cat "<body>" text "</body>")))
(def h1 (fn (text) (cat "<h1>" text "</h1>
")))
(def h2 (fn (text) (cat "<h2>" text "</h2>")))
(def p (fn (text) (cat "<p>" text "</p>
")))

(def htmlize (fn (po)
  (cat
    (h2 po's title)
    (p po's body))))

(def p1 (post "Hey" "This is a post"))
(def p2 (post "This" "Is ALSO a post"))

(prnl (html (body (cat 
        (h1 "This is Sage's Blog")
        (htmlize p1)
        (htmlize p2)
        ))))
